'*********************************************************************
'                            COUNT_A.BAS
'                        13.04.2004 (ddmmyyyy)
'
'(c) Ing.Bro Lehmann, Frstenbergstrae 8a. D-77756 Hausach
'Tel. +49 (0)7831 452   Fax. +49 (0)7831 96428    SL@il-online.de
'*********************************************************************

'Program COUNT_A.BAS is written for FLASH OF INSPRIRATION I. It will 
'run on this board without any modification. To run on other demo boards
'changes might be necessary.

'COUNT_A counts from 00 to 99 on the 7 segment display. Increment interval
'is about 0.5 second.
'Please connect LD1 with Port A 1 and LD2 with Port A 0. This signals becomes
'so called "digit select signal" and turn on and off the digits

'xtal on board. iL_BAS16 needs it for exact calculation of sofware
'delays and other timings
         xtal 20                              

'defines which PIC is used, what oscillator type, all io pins will be
'digital io, and watchdog is turned off
         define device 16F628
	 config hs_osc
         config cmcfg7
         config wdt_off
         config mclr_int
         
         define COUNT = $20 as byte    'contents the count value
         define TEMP = $21 as byte     'sometimes we need a 
                                       'temporary variable
         define PATTERN = $22 as byte  'return value of BIN2SEG
         define II = $23 as byte       'for FOR-NEXT loop

         
'This is the entry point on POWER ON or RESET
COLD:
         goto START                    'skip over all subroutines.

'INIT initializes the pins on port A and B to become output
INIT:
         tris RA,0                     '0 = Output; 1 = Input
         tris RB,0
         return
                  
'BIN2SEG converts a number between 0 and 9 into a bit pattern
'for the 7 segment display
BIN2SEG:
         if TEMP = 0 then let PATTERN = %00111111
         if TEMP = 1 then let PATTERN = %00000110
         if TEMP = 2 then let PATTERN = %01011011
         if TEMP = 3 then let PATTERN = %01001111
         if TEMP = 4 then let PATTERN = %01100110
         if TEMP = 5 then let PATTERN = %01101101
         if TEMP = 6 then let PATTERN = %01111101
         if TEMP = 7 then let PATTERN = %00000111
         if TEMP = 8 then let PATTERN = %01111111
         if TEMP = 9 then let PATTERN = %01101111
         if TEMP > 9 then let PATTERN = %01111001    'visible as 'E'
         return
                  
'DISP converts the contents of COUNT to a bit pattern so we can 
'recognize it as a number
DISP:
         let TEMP = COUNT AND 15       'first the right digit
         gosub BIN2SEG                 'convert in pattern
         output RB,PATTERN             'put it on Port B
         set RA,0                      'turn on digit
         wait 5                        'delay, so we can see anything
         res RA,0                      'turn off
         let TEMP = COUNT AND $F0
         swap TEMP                     'exchange high and low nibble
         gosub BIN2SEG
         output RB,PATTERN
         set RA,1                      'turn on left digit
         wait 5
         res RA,1                      'turn off left digit
         return
         
START:
         gosub INIT
         let COUNT = 0                 'start with 00
LOOP:
         for II = 1 to 100             'most of the time we have to wait
           gosub DISP                  'and serve the display, so it seems
         next II                       'to be static even it is multiplexed
                                       '1 .. 100 becames a delay of about
                                       '0,5 seconds
                                       
         inc COUNT                     'add 1 to COUNT
         let TEMP = COUNT AND 15       'hey, we want a decimal counter
         if TEMP < 10 then goto LOOP   'did we reached 10? If no, all's ok
                                       'no, we need a carry to next stage
         let COUNT = COUNT and $f0     'so last signifigant digit becomes 0
         let COUNT = COUNT + $10       'and most signif. digit plus 1
         let TEMP = COUNT and $f0      'did we reached 100?
         if TEMP < $a0 then goto LOOP  'no, all is ok
         let COUNT = 0                 'yes, we have to start from zero again
         goto LOOP
         
         end