'****************************************************************************
'                            Vor- und Rckwrtszhler
'                                F_R_Counter.BAS
'
'                               Stand: 24.06.2009
'
'                                  4. Schritt 
'
'(c) Ing.Bro Lehmann, Frstenbergstrae 8a, 77756 Hausach, www.iL-online.de
'****************************************************************************

'Historie
'Schritt4: es wird auf de hintersten Stelle von 0 bis 9 hochgezhlt
'          zum ersten Mal wird eine Variable definiert, ein Unterprogamm
'          zur Zeichenumsetzung verwendet und der TRIS-Befehl eingesetzt
'Schritt3: nun soll das Segment blinken
'Schritt2: weil mehr wie ein Segment leuchten, werden die brigen explizit 
'          abgeschaltet.

'Besonderheiten
'Auf der PICUP-Platine mssen die Steckbrcken (Jumper) wie folgt gesteckt sein:
'JP1A und JP1B  jeweils 2-3   -> externer Oszillator (Quarz)
'JP2A und JP2B  jeweils 2-3   -> T3 an RA1  und T2 an RA2

'die beiden nachfolgenden Schalter sind notwendig, wenn das PicKit2 als
'Programmiergert verwendet wird.
         $LIST  /M_OBJ
         $LIST  OBJ2HEX

'hier wird der Prozessortyp und dessen Spezifikationen definiert
         DEFINE DEVICE 16F628A
         CONFIG CMCFG7                 'interene Komparatoren abschalten, damit
                                       'die Pins als normale Ein-/Ausgnge arbeiten
         CONFIG HS_OSC                 'Wenn ein Quarz verwendet wird
         CONFIG MCLR_INT               'der MCLR-Pin soll als IO-Pin arbeiten
         CONFIG WDT_OFF                'verhindert, dass nach 2,3 Sek ein Reset 
                                       'erzeugt wird
         
         XTAL   4.096
         
'hier folgen die Variablendeklarationen (8, 16 und ggf. 32 Bit)         
         DEFINE    Count = AUTO AS BYTE          'Zhlervariable
         DEFINE    Muster = AUTO AS BYTE         'Segmentmuster

'hier werden die Bitvariablen definiert


'hier werden die Konstanten definiert

'-------------------------------------------
'ab hier wird Code fr den Prozessor erzeugt
'-------------------------------------------
'falls Unterprogramme verwendet werden, werden diese zuerst bersprungen

cold:
         GOTO      start
         
'hier stehen ggf. die Unterprogramme

'bcd2seg wandelt eine Zahl zwischen 0 und 9 in ein Bitmuster fr die
'Siebensegmentanzeige um
bcd2seg:
         IF        Count=0 THEN LET Muster = %00100001
         IF        Count=1 THEN LET Muster = %01111101
         IF        Count=2 THEN LET Muster = %00010011
         IF        Count=3 THEN LET Muster = %00011001
         IF        Count=4 THEN LET Muster = %01001101
         IF        Count=5 THEN LET Muster = %10001001
         IF        Count=6 THEN LET Muster = %10000001
         IF        Count=7 THEN LET Muster = %00111101
         IF        Count=8 THEN LET Muster = %00000001
         IF        Count=9 THEN LET Muster = %00001001
         RETURN

'hier beginnt das Hauptprogramm
start:
         LOW       RA,1                '?. Digit (T?) ausschalten
         LOW       RA,2                '?. Digit (T?) ausschalten
         LOW       RA,4                '?. Digit (T?) ausschalten
         LET       Count = 0           'Zhler mit 0 initialisieren
         TRIS      RB,0                'alle Pins von RB arbeiten als Ausgnge
loop:         
         GOSUB     bcd2seg             'Zahl in Count umwandeln in Seg.muster
         OUTPUT    RB,Muster           'dieses Muster an Port RB anlegen

         HIGH      RA,0                '1. Digit (T4) einschalten

         WAIT      500                 'Segment bleibt 500 ms ein

         LOW       RA,0                '1. Digit (T4) ausschalten
         LET       Count=Count+1       'Zhler hochzhlen lassen
         IF        Count=10 THEN LET Count=0  'Zhler zhlt nur bis 9
         
         GOTO      LOOP                'das Ganze luft nun endlos

         END
         
